/*
 * pthread/pthread-echo.c --
 *
 *      A simple program to start and join threads.
 */

#define _POSIX_C_SOURCE 200809L
#define _REENTRANT
#define _DEFAULT_SOURCE

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>

static void*
work(void *data)
{
    char *msg = (char *) data;
    (void) printf("%s ", msg);
    return NULL;
}

int
main(int argc, char *argv[])
{
    int i, r;
    pthread_t tids[argc];

    for (i = 1; i < argc; i++) {
        r = pthread_create(&tids[i], NULL, work, argv[i]);
        if (r) {
            fprintf(stderr, "failed to create thread: %s\n", strerror(r));
        }
    }

    for (i = 1; i < argc; i++) {
        if (tids[i]) {
            (void) pthread_join(tids[i], NULL);
        }
    }
    (void) printf("\n");

    return EXIT_SUCCESS;
}
